/*Copyright (C) 2010-2011, Mozilla Corporation.

  All rights reserved.

  Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice,
       this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice,
       this list of conditions and the following disclaimer in the
       documentation and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
  POSSIBILITY OF SUCH DAMAGE.*/
#if !defined(OPUS_H)
# define OPUS_H (1)
# include <stddef.h>
# include <stdint.h>



typedef int16_t  opus_int16;
typedef uint16_t opus_uint16;
typedef int32_t  opus_int32;
typedef uint32_t opus_uint32;
typedef int64_t  opus_int64;

/*Uses the same API semantics as fread().*/
typedef size_t (*opus_read_func)(unsigned char *_buf,
 size_t _size,size_t _nmemb,void *_stream);

typedef struct opus_stream_decoder opus_stream_decoder;



opus_stream_decoder *opus_stream_decoder_alloc(int _nchannels,
 opus_read_func _read,void *_stream);
void opus_stream_decoder_free(opus_stream_decoder *_dec);

int opus_decode_frame(opus_stream_decoder *_dec,float *_pcm,
 opus_uint32 _packet_length);

#endif
