/*Copyright (C) 2010-2011, Mozilla Corporation.

  All rights reserved.

  Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice,
       this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice,
       this list of conditions and the following disclaimer in the
       documentation and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
  POSSIBILITY OF SUCH DAMAGE.*/
#include "silkdata.h"



const unsigned char SILK_LBRR_FLAG_PDFS[4+8]={
  0, 53, 53,150,
  0, 41, 20, 29, 41, 15, 28, 82,
};


const unsigned char SILK_STEREO_WEIGHTS_STAGE1_PDF[25]={
  7,  2,  1,  1,  1, 10, 24,  8,  1,  1,
  3, 23, 92, 23,  3,  1,  1,  8, 24, 10,
  1,  1,  1,  2,  7
};

const unsigned char SILK_STEREO_WEIGHTS_STAGE2_PDF[3]={
  85, 86, 85
};

const unsigned char SILK_STEREO_WEIGHTS_STAGE3_PDF[5]={
  51, 51, 52, 51, 51
};

const unsigned char SILK_MID_ONLY_PDF[2]={
  192, 64
};


const unsigned char SILK_FRAME_TYPE_PDFS[2+6]={
  26,230,
   0,  0, 24, 74,148, 10
};


const unsigned char SILK_GAIN_HIGH_PDFS[3*8]={
  32,112, 68, 29, 12,  1,  1,  1,
   2, 17, 45, 60, 62, 47, 19,  4,
   1,  3, 26, 71, 94, 50,  9,  2
};

const unsigned char SILK_GAIN_LOW_PDF[8]={
  32, 32, 32, 32, 32, 32, 32, 32
};

const unsigned char SILK_GAIN_DELTA_PDF[41]={
  6,  5, 11, 31,132, 21,  8,  4,  3,  2,  2,  2,  1,  1,
  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1
};


const unsigned char SILK_NLSF_STAGE2_EXT_PDF[7]={
  156, 60, 24,  9,  4,  2,  1
};

const unsigned char SILK_NLSF_INTERP_WEIGHT_PDF[5]={
  13, 22, 29, 11,181
};


const unsigned char SILK_PITCH_LAG_HIGH_PDF[32]={
  3,  3,  6, 11, 21, 30, 32, 19, 11, 10, 12, 13, 13, 12, 11,  9,
  8,  7,  6,  4,  2,  2,  2,  1,  1,  1,  1,  1,  1,  1,  1,  1
};


#define SILK_NB_PITCH_LAG_LOW_PDF SILK_LCG_SEED_PDF

static const unsigned char SILK_MB_PITCH_LAG_LOW_PDF[6]={
  43, 42, 43, 43, 42, 43
};

#define SILK_WB_PITCH_LAG_LOW_PDF SILK_GAIN_LOW_PDF

const unsigned char *const SILK_PITCH_LAG_LOW_PDFS[3]={
  SILK_NB_PITCH_LAG_LOW_PDF,
  SILK_MB_PITCH_LAG_LOW_PDF,
  SILK_WB_PITCH_LAG_LOW_PDF
};


const unsigned char SILK_PITCH_LAG_DELTA_PDF[21]={
  46,  2,  2,  3,  4,  6, 10, 15, 26, 38, 30, 22,
  15, 10,  7,  6,  4,  4,  2,  2,  2
};

const unsigned char SILK_SUBFRAME_PITCH_PDFS[60]={
  /*10 ms NB frames:*/
  143, 50, 63,
  /*20 ms NB frames:*/
   68, 12, 21, 17, 19, 22, 30, 24, 17, 16, 10,
  /*10 ms MB or WB frames:*/
   91, 46, 39, 19, 14, 12,  8,  7,  6,  5,  5,  4,
  /*20 ms MB or WB frames:*/
   33, 22, 18, 16, 15, 14, 14, 13, 13, 10,  9,  9,  8,  6,  6,  6,
    5,  4,  4,  4,  3,  3,  3,  2,   2,  2,  2,  2,  2,  2,  1,  1,
    1,  1
};

const unsigned char SILK_SUBFRAME_PITCH_PDF_OFFS[4]={
  0, 3,14,26
};

const unsigned char SILK_PERIODICITY_INDEX_PDF[3]={
  77, 80, 99
};

const unsigned char SILK_LTP_FILTER_PDFS[56]={
  /*Periodicity Index 0:*/
  185, 15, 13, 13,  9,  9,  6,  6,
  /*Periodicity Index 1:*/
   57, 34, 21, 20, 15, 13, 12, 13, 10, 10,  9, 10,  9,  8,  7,  8,
  /*Periodicity Index 2:*/
   15, 16, 14, 12, 12, 12, 11, 11, 11, 10,  9,  9,  9,  9,  8,  8,
    8,  8,  7,  7,  6,  6,  5,  4,  5,  4,  4,  4,  3,  4,  3,  2
};

const unsigned char SILK_LTP_FILTER_PDF_OFFS[3]={
  0, 8,24
};

const unsigned char SILK_LTP_SCALE_PDF[3]={
  128, 64, 64
};


const unsigned char SILK_LCG_SEED_PDF[4]={
  64, 64, 64, 64
};


const unsigned char SILK_RATE_LEVEL_PDFS[18]={
  /*Inactive or Unvoiced:*/
  15, 51, 12, 46, 45, 13, 33, 27, 14,
  /*Voiced:*/
  33, 30, 36, 17, 34, 49, 18, 21, 18
};

const unsigned char SILK_PULSE_COUNT_PDFS[18*11-1]={
  /*Rate level 0:*/
  131, 74, 25,  8,  3,  3,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
  /*Rate level 1:*/
   58, 93, 60, 23,  7,  3,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
  /*Rate level 2:*/
   43, 51, 46, 33, 24, 16, 11,  8,  6,  3,  3,  3,  2,  1,  1,  2,  1,  2,
  /*Rate level 3:*/
   17, 52, 71, 57, 31, 12,  5,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
  /*Rate level 4:*/
    6, 21, 41, 53, 49, 35, 21, 11,  6,  3,  2,  2,  1,  1,  1,  1,  1,  1,
  /*Rate level 5:*/
    7, 14, 22, 28, 29, 28, 25, 20, 17, 13, 11,  9,  7,  5,  4,  4,  3, 10,
  /*Rate level 6:*/
    2,  5, 14, 29, 42, 46, 41, 31, 19, 11,  6,  3,  2,  1,  1,  1,  1,  1,
  /*Rate level 7:*/
    1,  2,  4, 10, 19, 29, 35, 37, 34, 28, 20, 14,  8,  5,  4,  2,  2,  2,
  /*Rate level 8:*/
    1,  2,  2,  5,  9, 14, 20, 24, 27, 28, 26, 23, 20, 15, 11,  8,  6, 15,
  /*Rate level 9:*/
    1,  1,  1,  6, 27, 58, 56, 39, 25, 14, 10,  6,  3,  3,  2,  1,  1,  2,
  /*Rate level 10:*/
    2,  1,  6, 27, 58, 56, 39, 25, 14, 10,  6,  3,  3,  2,  1,  1,  2
};

const unsigned char SILK_SPLIT_PDFS[152*4]={
  /*2-sample partitions:*/
  128,128,
   42,172, 42,
   21,107,107, 21,
   12, 60,112, 61, 11,
    8, 34, 86, 86, 35,  7,
    8, 23, 55, 90, 55, 20,  5,
    5, 15, 38, 72, 72, 36, 15,  3,
    6, 12, 27, 52, 77, 47, 20, 10,  5,
    6, 19, 28, 35, 40, 40, 35, 28, 19,  6,
    4, 14, 22, 31, 37, 40, 37, 31, 22, 14,  4,
    3, 10, 18, 26, 33, 38, 38, 33, 26, 18, 10,  3,
    2,  8, 13, 21, 29, 36, 38, 36, 29, 21, 13,  8,  2,
    1,  5, 10, 17, 25, 32, 38, 38, 32, 25, 17, 10,  5,  1,
    1,  4,  7, 13, 21, 29, 35, 36, 35, 29, 21, 13,  7,  4,  1,
    1,  2,  5, 10, 17, 25, 32, 36, 36, 32, 25, 17, 10,  5,  2,  1,
    1,  2,  4,  7, 13, 21, 28, 34, 36, 34, 28, 21, 13,  7,  4,  2,  1,
  /*4-sample partitions:*/
  127,129,
   49,157, 50,
   20,107,109, 20,
   11, 60,113, 62, 10,
    7, 36, 84, 87, 36,  6,
    6, 24, 57, 82, 60, 23,  4,
    5, 18, 39, 64, 68, 42, 16,  4,
    6, 14, 29, 47, 61, 52, 30, 14,  3,
    1, 15, 23, 35, 51, 50, 40, 30, 10,  1,
    1,  1, 21, 32, 42, 52, 46, 41, 18,  1,  1,
    1,  6, 16, 27, 36, 42, 42, 36, 27, 16,  6,  1,
    1,  5, 12, 21, 31, 38, 40, 38, 31, 21, 12,  5,  1,
    1,  3,  9, 17, 26, 34, 38, 38, 34, 26, 17,  9,  3,  1,
    1,  3,  7, 14, 22, 29, 34, 36, 34, 29, 22, 14,  7,  3,  1,
    1,  2,  5, 11, 18, 25, 31, 35, 35, 31, 25, 18, 11,  5,  2,  1,
    1,  1,  4,  9, 15, 21, 28, 32, 34, 32, 28, 21, 15,  9,  4,  1,  1,
  /*8-sample partitions:*/
  127,129,
   53,149, 54,
   22,105,106, 23,
   11, 61,111, 63, 10,
    6, 35, 86, 88, 36,  5,
    4, 20, 59, 87, 62, 21,  3,
    3, 13, 40, 71, 73, 41, 13,  2,
    3,  9, 27, 53, 70, 56, 28,  9,  1,
    3,  8, 19, 37, 57, 61, 44, 20,  6,  1,
    3,  7, 15, 28, 44, 54, 49, 33, 17,  5,  1,
    1,  7, 13, 22, 34, 46, 48, 38, 28, 14,  4,  1,
    1,  1, 11, 22, 27, 35, 42, 47, 33, 25, 10,  1,  1,
    1,  1,  6, 14, 26, 37, 43, 43, 37, 26, 14,  6,  1,  1,
    1,  1,  4, 10, 20, 31, 40, 42, 40, 31, 20, 10,  4,  1,  1,
    1,  1,  3,  8, 16, 26, 35, 38, 38, 35, 26, 16,  8,  3,  1,  1,
    1,  1,  2,  6, 12, 21, 30, 36, 38, 36, 30, 21, 12,  6,  2,  1,  1,
  /*16-sample partitions:*/
  126,130,
   56,142, 58,
   25,101,104, 26,
   12, 60,108, 64, 12,
    7, 35, 84, 87, 37,  6,
    4, 20, 59, 86, 63, 21,  3,
    3, 12, 38, 72, 75, 42, 12,  2,
    2,  8, 25, 54, 73, 59, 27,  7,  1,
    2,  5, 17, 39, 63, 65, 42, 18,  4,  1,
    1,  4, 12, 28, 49, 63, 54, 30, 11,  3,  1,
    1,  4,  8, 20, 37, 55, 57, 41, 22,  8,  2,  1,
    1,  3,  7, 15, 28, 44, 53, 48, 33, 16,  6,  1,  1,
    1,  2,  6, 12, 21, 35, 47, 48, 40, 25, 12,  5,  1,  1,
    1,  1,  4, 10, 17, 27, 37, 47, 43, 33, 21,  9,  4,  1,  1,
    1,  1,  1,  8, 14, 22, 33, 40, 43, 38, 28, 16,  8,  1,  1,  1,
    1,  1,  1,  1, 13, 18, 27, 36, 41, 41, 34, 24, 14,  1,  1,  1,  1
};

const unsigned char SILK_LSB_PDF[2]={
  136,120
};

const unsigned char SILK_SIGN_PDFS[6*7*2]={
  /*Inactive, low quant offset.*/
   2,254,207, 49,189, 67,179, 77,174, 82,163, 93,157, 99,
  /*Inactive, high quant offset.*/
  58,198,245, 11,238, 18,232, 24,225, 31,220, 36,211, 45,
  /*Unvoiced, low quant offset.*/
   1,255,210, 46,190, 66,178, 78,169, 87,162, 94,152,104,
  /*Unvoiced, high quant offset.*/
  48,208,242, 14,235, 21,224, 32,214, 42,205, 51,190, 66,
  /*Voiced, low quant offset.*/
   1,255,162, 94,152,104,147,109,144,112,141,115,138,118,
  /*Voiced, high quant offset.*/
   8,248,203, 53,187, 69,176, 80,168, 88,161, 95,154,102
};


const opus_int16 SILK_STEREO_WEIGHTS_Q13[15]={
  -13732,-10050, -8266, -7526, -6500, -5000, -2950,  -820,
     820,  2950,  5000,  6500,  7526,  8266, 10050
};

const opus_int16 SILK_STEREO_WEIGHT_DELTAS_Q13[15]={
  368,178, 74,102,150,205,213,164,213,205,150,102, 74,178,368
};



static const unsigned char SILK_NBMB_NLSF_STAGE1_CB_Q8[32*10]={
  12, 35, 60, 83,108,132,157,180,206,228,
  15, 32, 55, 77,101,125,151,175,201,225,
  19, 42, 66, 89,114,137,162,184,209,230,
  12, 25, 50, 72, 97,120,147,172,200,223,
  26, 44, 69, 90,114,135,159,180,205,225,
  13, 22, 53, 80,106,130,156,180,205,228,
  15, 25, 44, 64, 90,115,142,168,196,222,
  19, 24, 62, 82,100,120,145,168,190,214,
  22, 31, 50, 79,103,120,151,170,203,227,
  21, 29, 45, 65,106,124,150,171,196,224,
  30, 49, 75, 97,121,142,165,186,209,229,
  19, 25, 52, 70, 93,116,143,166,192,219,
  26, 34, 62, 75, 97,118,145,167,194,217,
  25, 33, 56, 70, 91,113,143,165,196,223,
  21, 34, 51, 72, 97,117,145,171,196,222,
  20, 29, 50, 67, 90,117,144,168,197,221,
  22, 31, 48, 66, 95,117,146,168,196,222,
  24, 33, 51, 77,116,134,158,180,200,224,
  21, 28, 70, 87,106,124,149,170,194,217,
  26, 33, 53, 64, 83,117,152,173,204,225,
  27, 34, 65, 95,108,129,155,174,210,225,
  20, 26, 72, 99,113,131,154,176,200,219,
  34, 43, 61, 78, 93,114,155,177,205,229,
  23, 29, 54, 97,124,138,163,179,209,229,
  30, 38, 56, 89,118,129,158,178,200,231,
  21, 29, 49, 63, 85,111,142,163,193,222,
  27, 48, 77,103,133,158,179,196,215,232,
  29, 47, 74, 99,124,151,176,198,220,237,
  33, 42, 61, 76, 93,121,155,174,207,225,
  29, 53, 87,112,136,154,170,188,208,227,
  24, 30, 52, 84,131,150,166,186,203,229,
  37, 48, 64, 84,104,118,156,177,201,230
};

/*Packs 2 columns of Table 17 and Table 21 from the spec into a single byte.
  Since Table 21 has one less column than Table 17, the last entry in each row
   is unused.*/
#define SILK_PACK_NLSF_IDXS0(_pdf0,_w0,_pdf1,_w1) \
 ((_w1)-'A'<<7|(_pdf1)-'a'<<4|(_w0)-'A'<<3|(_pdf0)-'a')

static const unsigned char SILK_NBMB_NLSF_STAGE2_INDICES[32*5]={
  /*I1=0*/
  SILK_PACK_NLSF_IDXS0('a','A','a','B'),SILK_PACK_NLSF_IDXS0('a','A','a','A'),
  SILK_PACK_NLSF_IDXS0('a','A','a','A'),SILK_PACK_NLSF_IDXS0('a','A','a','A'),
  SILK_PACK_NLSF_IDXS0('a','A','a','A'),
  /*I1=1*/
  SILK_PACK_NLSF_IDXS0('b','B','d','A'),SILK_PACK_NLSF_IDXS0('b','A','c','A'),
  SILK_PACK_NLSF_IDXS0('c','A','b','A'),SILK_PACK_NLSF_IDXS0('c','A','b','A'),
  SILK_PACK_NLSF_IDXS0('b','A','b','A'),
  /*I1=2*/
  SILK_PACK_NLSF_IDXS0('c','A','b','A'),SILK_PACK_NLSF_IDXS0('b','A','b','A'),
  SILK_PACK_NLSF_IDXS0('b','A','b','A'),SILK_PACK_NLSF_IDXS0('b','A','b','A'),
  SILK_PACK_NLSF_IDXS0('b','A','b','A'),
  /*I1=3*/
  SILK_PACK_NLSF_IDXS0('b','B','c','B'),SILK_PACK_NLSF_IDXS0('c','B','c','A'),
  SILK_PACK_NLSF_IDXS0('c','A','b','A'),SILK_PACK_NLSF_IDXS0('c','A','b','B'),
  SILK_PACK_NLSF_IDXS0('b','A','b','A'),
  /*I1=4*/
  SILK_PACK_NLSF_IDXS0('c','A','d','B'),SILK_PACK_NLSF_IDXS0('d','A','d','A'),
  SILK_PACK_NLSF_IDXS0('d','A','c','A'),SILK_PACK_NLSF_IDXS0('c','A','c','A'),
  SILK_PACK_NLSF_IDXS0('c','A','c','A'),
  /*I1=5*/
  SILK_PACK_NLSF_IDXS0('a','A','f','B'),SILK_PACK_NLSF_IDXS0('d','A','d','A'),
  SILK_PACK_NLSF_IDXS0('c','A','c','A'),SILK_PACK_NLSF_IDXS0('c','A','c','A'),
  SILK_PACK_NLSF_IDXS0('b','A','b','A'),
  /*I1=6*/
  SILK_PACK_NLSF_IDXS0('a','B','c','A'),SILK_PACK_NLSF_IDXS0('c','B','c','B'),
  SILK_PACK_NLSF_IDXS0('c','A','c','A'),SILK_PACK_NLSF_IDXS0('c','A','c','B'),
  SILK_PACK_NLSF_IDXS0('c','A','b','A'),
  /*I1=7*/
  SILK_PACK_NLSF_IDXS0('c','A','d','B'),SILK_PACK_NLSF_IDXS0('g','B','e','A'),
  SILK_PACK_NLSF_IDXS0('e','A','e','B'),SILK_PACK_NLSF_IDXS0('f','B','e','A'),
  SILK_PACK_NLSF_IDXS0('f','A','f','A'),
  /*I1=8*/
  SILK_PACK_NLSF_IDXS0('c','A','e','A'),SILK_PACK_NLSF_IDXS0('f','B','f','B'),
  SILK_PACK_NLSF_IDXS0('e','A','f','B'),SILK_PACK_NLSF_IDXS0('e','A','g','B'),
  SILK_PACK_NLSF_IDXS0('e','B','e','A'),
  /*I1=9*/
  SILK_PACK_NLSF_IDXS0('c','A','e','A'),SILK_PACK_NLSF_IDXS0('e','B','h','B'),
  SILK_PACK_NLSF_IDXS0('e','A','f','A'),SILK_PACK_NLSF_IDXS0('e','B','f','B'),
  SILK_PACK_NLSF_IDXS0('f','B','e','A'),
  /*I1=10*/
  SILK_PACK_NLSF_IDXS0('e','A','d','A'),SILK_PACK_NLSF_IDXS0('d','A','d','A'),
  SILK_PACK_NLSF_IDXS0('c','A','d','A'),SILK_PACK_NLSF_IDXS0('c','A','c','A'),
  SILK_PACK_NLSF_IDXS0('c','A','c','A'),
  /*I1=11*/
  SILK_PACK_NLSF_IDXS0('b','A','f','B'),SILK_PACK_NLSF_IDXS0('f','A','g','B'),
  SILK_PACK_NLSF_IDXS0('e','B','f','B'),SILK_PACK_NLSF_IDXS0('e','B','f','B'),
  SILK_PACK_NLSF_IDXS0('f','A','f','A'),
  /*I1=12*/
  SILK_PACK_NLSF_IDXS0('c','A','h','B'),SILK_PACK_NLSF_IDXS0('e','A','g','B'),
  SILK_PACK_NLSF_IDXS0('f','B','f','B'),SILK_PACK_NLSF_IDXS0('f','B','f','B'),
  SILK_PACK_NLSF_IDXS0('f','A','f','A'),
  /*I1=13*/
  SILK_PACK_NLSF_IDXS0('c','A','h','B'),SILK_PACK_NLSF_IDXS0('f','B','f','B'),
  SILK_PACK_NLSF_IDXS0('f','B','f','B'),SILK_PACK_NLSF_IDXS0('f','B','g','B'),
  SILK_PACK_NLSF_IDXS0('f','A','e','A'),
  /*I1=14*/
  SILK_PACK_NLSF_IDXS0('d','B','d','A'),SILK_PACK_NLSF_IDXS0('f','B','e','B'),
  SILK_PACK_NLSF_IDXS0('e','A','f','B'),SILK_PACK_NLSF_IDXS0('e','B','f','B'),
  SILK_PACK_NLSF_IDXS0('e','B','e','A'),
  /*I1=15*/
  SILK_PACK_NLSF_IDXS0('c','A','d','B'),SILK_PACK_NLSF_IDXS0('d','B','f','B'),
  SILK_PACK_NLSF_IDXS0('f','B','e','B'),SILK_PACK_NLSF_IDXS0('e','A','e','B'),
  SILK_PACK_NLSF_IDXS0('e','A','e','A'),
  /*I1=16*/
  SILK_PACK_NLSF_IDXS0('c','A','e','A'),SILK_PACK_NLSF_IDXS0('e','B','g','B'),
  SILK_PACK_NLSF_IDXS0('e','A','f','B'),SILK_PACK_NLSF_IDXS0('e','A','f','B'),
  SILK_PACK_NLSF_IDXS0('f','A','f','A'),
  /*I1=17*/
  SILK_PACK_NLSF_IDXS0('c','A','f','A'),SILK_PACK_NLSF_IDXS0('e','B','g','B'),
  SILK_PACK_NLSF_IDXS0('f','B','f','A'),SILK_PACK_NLSF_IDXS0('f','B','e','B'),
  SILK_PACK_NLSF_IDXS0('f','B','e','A'),
  /*I1=18*/
  SILK_PACK_NLSF_IDXS0('c','A','h','B'),SILK_PACK_NLSF_IDXS0('e','B','f','A'),
  SILK_PACK_NLSF_IDXS0('e','A','f','B'),SILK_PACK_NLSF_IDXS0('e','B','f','B'),
  SILK_PACK_NLSF_IDXS0('f','A','f','A'),
  /*I1=19*/
  SILK_PACK_NLSF_IDXS0('c','A','f','A'),SILK_PACK_NLSF_IDXS0('e','A','g','B'),
  SILK_PACK_NLSF_IDXS0('h','B','g','B'),SILK_PACK_NLSF_IDXS0('f','A','g','B'),
  SILK_PACK_NLSF_IDXS0('f','A','e','A'),
  /*I1=20*/
  SILK_PACK_NLSF_IDXS0('d','A','g','B'),SILK_PACK_NLSF_IDXS0('h','B','e','A'),
  SILK_PACK_NLSF_IDXS0('g','A','f','B'),SILK_PACK_NLSF_IDXS0('f','A','g','B'),
  SILK_PACK_NLSF_IDXS0('e','A','f','A'),
  /*I1=21*/
  SILK_PACK_NLSF_IDXS0('c','A','h','B'),SILK_PACK_NLSF_IDXS0('g','B','e','A'),
  SILK_PACK_NLSF_IDXS0('e','A','e','A'),SILK_PACK_NLSF_IDXS0('f','B','e','B'),
  SILK_PACK_NLSF_IDXS0('f','A','f','A'),
  /*I1=22*/
  SILK_PACK_NLSF_IDXS0('e','A','f','A'),SILK_PACK_NLSF_IDXS0('f','A','e','A'),
  SILK_PACK_NLSF_IDXS0('g','A','g','B'),SILK_PACK_NLSF_IDXS0('f','B','g','B'),
  SILK_PACK_NLSF_IDXS0('f','B','e','A'),
  /*I1=23*/
  SILK_PACK_NLSF_IDXS0('c','A','f','A'),SILK_PACK_NLSF_IDXS0('f','B','g','B'),
  SILK_PACK_NLSF_IDXS0('f','A','g','A'),SILK_PACK_NLSF_IDXS0('e','A','g','B'),
  SILK_PACK_NLSF_IDXS0('e','B','e','A'),
  /*I1=24*/
  SILK_PACK_NLSF_IDXS0('e','A','f','A'),SILK_PACK_NLSF_IDXS0('f','A','f','B'),
  SILK_PACK_NLSF_IDXS0('d','A','h','B'),SILK_PACK_NLSF_IDXS0('e','B','f','B'),
  SILK_PACK_NLSF_IDXS0('f','B','e','A'),
  /*I1=25*/
  SILK_PACK_NLSF_IDXS0('c','A','d','B'),SILK_PACK_NLSF_IDXS0('e','B','f','B'),
  SILK_PACK_NLSF_IDXS0('f','B','g','B'),SILK_PACK_NLSF_IDXS0('e','B','f','B'),
  SILK_PACK_NLSF_IDXS0('f','A','e','A'),
  /*I1=26*/
  SILK_PACK_NLSF_IDXS0('c','A','d','A'),SILK_PACK_NLSF_IDXS0('c','A','d','A'),
  SILK_PACK_NLSF_IDXS0('d','A','e','A'),SILK_PACK_NLSF_IDXS0('c','A','d','A'),
  SILK_PACK_NLSF_IDXS0('d','A','d','A'),
  /*I1=27*/
  SILK_PACK_NLSF_IDXS0('b','A','b','A'),SILK_PACK_NLSF_IDXS0('c','A','c','A'),
  SILK_PACK_NLSF_IDXS0('c','A','c','A'),SILK_PACK_NLSF_IDXS0('c','A','d','A'),
  SILK_PACK_NLSF_IDXS0('c','A','c','A'),
  /*I1=28*/
  SILK_PACK_NLSF_IDXS0('e','A','f','A'),SILK_PACK_NLSF_IDXS0('f','B','g','A'),
  SILK_PACK_NLSF_IDXS0('g','B','g','B'),SILK_PACK_NLSF_IDXS0('f','A','g','B'),
  SILK_PACK_NLSF_IDXS0('e','A','f','A'),
  /*I1=29*/
  SILK_PACK_NLSF_IDXS0('d','B','f','A'),SILK_PACK_NLSF_IDXS0('f','A','e','B'),
  SILK_PACK_NLSF_IDXS0('e','A','e','A'),SILK_PACK_NLSF_IDXS0('e','A','d','A'),
  SILK_PACK_NLSF_IDXS0('d','A','c','A'),
  /*I1=30*/
  SILK_PACK_NLSF_IDXS0('c','A','f','A'),SILK_PACK_NLSF_IDXS0('d','A','h','B'),
  SILK_PACK_NLSF_IDXS0('f','B','f','A'),SILK_PACK_NLSF_IDXS0('e','B','e','A'),
  SILK_PACK_NLSF_IDXS0('f','B','e','A'),
  /*I1=31*/
  SILK_PACK_NLSF_IDXS0('e','B','e','A'),SILK_PACK_NLSF_IDXS0('f','B','e','B'),
  SILK_PACK_NLSF_IDXS0('f','A','g','B'),SILK_PACK_NLSF_IDXS0('f','B','g','B'),
  SILK_PACK_NLSF_IDXS0('f','B','e','A')
};

static const unsigned char SILK_NBMB_NLSF_STAGE2_PRED_WEIGHTS_Q8[2*9]={
  179,138,140,148,151,149,153,151,163,
  116, 67, 82, 59, 92, 72,100, 89, 92
};

static const opus_int16 SILK_NBMB_NLSF_MIN_SPACING_Q15[11]={
  250,  3,  6,  3,  3,  3,  4,  3,  3,  3,461
};

static const unsigned char SILK_NBMB_NLSF_ORDERING[10]={
  0,9,6,3,4,5,8,1,2,7
};

static const silk_nlsf_codebook SILK_NBMB_NLSF_CODEBOOK={
  /*Stage 1 PDFs:*/
  {
    /*Inactive or Unvoiced:*/
    44, 34, 30, 19, 21, 12, 11,  3,  3,  2, 16,  2,  2,  1,  5,  2,
     1,  3,  3,  1,  1,  2,  2,  2,  3,  1,  9,  9,  2,  7,  2,  1,
    /*Voiced:*/
     1, 10,  1,  8,  3,  8,  8, 14, 13, 14,  1, 14, 12, 13, 11, 11,
    12, 11, 10, 10, 11,  8,  9,  8,  7,  8,  1,  1,  6,  1,  6,  5
  },
  /*Stage 2 PDFs:*/
  {
    1,  1,  1, 15, 224, 11,  1,  1,  1,
    1,  1,  2, 34, 183, 32,  1,  1,  1,
    1,  1,  4, 42, 149, 55,  2,  1,  1,
    1,  1,  8, 52, 123, 61,  8,  1,  1,
    1,  3, 16, 53, 101, 74,  6,  1,  1,
    1,  3, 17, 55,  90, 73, 15,  1,  1,
    1,  7, 24, 53,  74, 67, 26,  3,  1,
    1,  1, 18, 63,  78, 58, 30,  6,  1
  },
  SILK_NBMB_NLSF_STAGE1_CB_Q8,
  SILK_NBMB_NLSF_STAGE2_INDICES,
  SILK_NBMB_NLSF_STAGE2_PRED_WEIGHTS_Q8,
  SILK_NBMB_NLSF_MIN_SPACING_Q15,
  SILK_NBMB_NLSF_ORDERING,
  11796,
  10
};


static const unsigned char SILK_WB_NLSF_STAGE1_CB_Q8[32*16]={
   7, 23, 38, 54, 69, 85,100,116,131,147,162,178,193,208,223,239,
  13, 25, 41, 55, 69, 83, 98,112,127,142,157,171,187,203,220,236,
  15, 21, 34, 51, 61, 78, 92,106,126,136,152,167,185,205,225,240,
  10, 21, 36, 50, 63, 79, 95,110,126,141,157,173,189,205,221,237,
  17, 20, 37, 51, 59, 78, 89,107,123,134,150,164,184,205,224,240,
  10, 15, 32, 51, 67, 81, 96,112,129,142,158,173,189,204,220,236,
   8, 21, 37, 51, 65, 79, 98,113,126,138,155,168,179,192,209,218,
  12, 15, 34, 55, 63, 78, 87,108,118,131,148,167,185,203,219,236,
  16, 19, 32, 36, 56, 79, 91,108,118,136,154,171,186,204,220,237,
  11, 28, 43, 58, 74, 89,105,120,135,150,165,180,196,211,226,241,
   6, 16, 33, 46, 60, 75, 92,107,123,137,156,169,185,199,214,225,
  11, 19, 30, 44, 57, 74, 89,105,121,135,152,169,186,202,218,234,
  12, 19, 29, 46, 57, 71, 88,100,120,132,148,165,182,199,216,233,
  17, 23, 35, 46, 56, 77, 92,106,123,134,152,167,185,204,222,237,
  14, 17, 45, 53, 63, 75, 89,107,115,132,151,171,188,206,221,240,
   9, 16, 29, 40, 56, 71, 88,103,119,137,154,171,189,205,222,237,
  16, 19, 36, 48, 57, 76, 87,105,118,132,150,167,185,202,218,236,
  12, 17, 29, 54, 71, 81, 94,104,126,136,149,164,182,201,221,237,
  15, 28, 47, 62, 79, 97,115,129,142,155,168,180,194,208,223,238,
   8, 14, 30, 45, 62, 78, 94,111,127,143,159,175,192,207,223,239,
  17, 30, 49, 62, 79, 92,107,119,132,145,160,174,190,204,220,235,
  14, 19, 36, 45, 61, 76, 91,108,121,138,154,172,189,205,222,238,
  12, 18, 31, 45, 60, 76, 91,107,123,138,154,171,187,204,221,236,
  13, 17, 31, 43, 53, 70, 83,103,114,131,149,167,185,203,220,237,
  17, 22, 35, 42, 58, 78, 93,110,125,139,155,170,188,206,224,240,
   8, 15, 34, 50, 67, 83, 99,115,131,146,162,178,193,209,224,239,
  13, 16, 41, 66, 73, 86, 95,111,128,137,150,163,183,206,225,241,
  17, 25, 37, 52, 63, 75, 92,102,119,132,144,160,175,191,212,231,
  19, 31, 49, 65, 83,100,117,133,147,161,174,187,200,213,227,242,
  18, 31, 52, 68, 88,103,117,126,138,149,163,177,192,207,223,239,
  16, 29, 47, 61, 76, 90,106,119,133,147,161,176,193,209,224,240,
  15, 21, 35, 50, 61, 73, 86, 97,110,119,129,141,175,198,218,237
};

/*Packs 2 columns of Table 18 and Table 22 from the spec into a single byte.
  Since Table 22 has one less column than Table 18, the last entry in each row
   is unused.*/
#define SILK_PACK_NLSF_IDXS1(_pdf0,_w0,_pdf1,_w1) \
 ((_w1)-'C'<<7|(_pdf1)-'i'<<4|(_w0)-'C'<<3|(_pdf0)-'i')

static const unsigned char SILK_WB_NLSF_STAGE2_INDICES[32*8]={
  /*I1=0*/
  SILK_PACK_NLSF_IDXS1('i','C','i','C'),SILK_PACK_NLSF_IDXS1('i','C','i','C'),
  SILK_PACK_NLSF_IDXS1('i','C','i','C'),SILK_PACK_NLSF_IDXS1('i','C','i','C'),
  SILK_PACK_NLSF_IDXS1('i','C','i','C'),SILK_PACK_NLSF_IDXS1('i','C','i','C'),
  SILK_PACK_NLSF_IDXS1('i','C','i','C'),SILK_PACK_NLSF_IDXS1('i','D','i','C'),
  /*I1=1*/
  SILK_PACK_NLSF_IDXS1('k','C','l','C'),SILK_PACK_NLSF_IDXS1('l','C','l','C'),
  SILK_PACK_NLSF_IDXS1('l','C','l','C'),SILK_PACK_NLSF_IDXS1('k','C','k','C'),
  SILK_PACK_NLSF_IDXS1('k','C','k','C'),SILK_PACK_NLSF_IDXS1('k','C','j','C'),
  SILK_PACK_NLSF_IDXS1('j','C','j','C'),SILK_PACK_NLSF_IDXS1('i','C','l','C'),
  /*I1=2*/
  SILK_PACK_NLSF_IDXS1('k','C','n','C'),SILK_PACK_NLSF_IDXS1('n','D','l','C'),
  SILK_PACK_NLSF_IDXS1('p','C','m','D'),SILK_PACK_NLSF_IDXS1('m','D','n','D'),
  SILK_PACK_NLSF_IDXS1('k','C','n','D'),SILK_PACK_NLSF_IDXS1('m','D','n','D'),
  SILK_PACK_NLSF_IDXS1('n','D','m','C'),SILK_PACK_NLSF_IDXS1('l','C','l','C'),
  /*I1=3*/
  SILK_PACK_NLSF_IDXS1('i','C','k','C'),SILK_PACK_NLSF_IDXS1('j','C','k','C'),
  SILK_PACK_NLSF_IDXS1('k','C','j','C'),SILK_PACK_NLSF_IDXS1('j','C','j','C'),
  SILK_PACK_NLSF_IDXS1('j','C','j','C'),SILK_PACK_NLSF_IDXS1('i','C','i','C'),
  SILK_PACK_NLSF_IDXS1('i','D','i','C'),SILK_PACK_NLSF_IDXS1('i','C','j','C'),
  /*I1=4*/
  SILK_PACK_NLSF_IDXS1('i','C','o','D'),SILK_PACK_NLSF_IDXS1('n','D','m','C'),
  SILK_PACK_NLSF_IDXS1('o','D','m','C'),SILK_PACK_NLSF_IDXS1('p','D','n','D'),
  SILK_PACK_NLSF_IDXS1('m','C','m','D'),SILK_PACK_NLSF_IDXS1('m','D','n','D'),
  SILK_PACK_NLSF_IDXS1('n','D','m','D'),SILK_PACK_NLSF_IDXS1('m','C','l','C'),
  /*I1=5*/
  SILK_PACK_NLSF_IDXS1('i','C','l','C'),SILK_PACK_NLSF_IDXS1('n','D','n','C'),
  SILK_PACK_NLSF_IDXS1('m','C','l','C'),SILK_PACK_NLSF_IDXS1('l','C','n','C'),
  SILK_PACK_NLSF_IDXS1('l','C','l','C'),SILK_PACK_NLSF_IDXS1('l','C','l','C'),
  SILK_PACK_NLSF_IDXS1('l','C','l','C'),SILK_PACK_NLSF_IDXS1('k','C','m','C'),
  /*I1=6*/
  SILK_PACK_NLSF_IDXS1('i','D','i','C'),SILK_PACK_NLSF_IDXS1('i','C','i','C'),
  SILK_PACK_NLSF_IDXS1('i','C','i','C'),SILK_PACK_NLSF_IDXS1('i','C','i','C'),
  SILK_PACK_NLSF_IDXS1('i','C','i','C'),SILK_PACK_NLSF_IDXS1('i','C','i','D'),
  SILK_PACK_NLSF_IDXS1('i','C','i','D'),SILK_PACK_NLSF_IDXS1('i','C','i','C'),
  /*I1=7*/
  SILK_PACK_NLSF_IDXS1('i','C','k','D'),SILK_PACK_NLSF_IDXS1('o','D','l','C'),
  SILK_PACK_NLSF_IDXS1('p','C','k','C'),SILK_PACK_NLSF_IDXS1('n','D','l','C'),
  SILK_PACK_NLSF_IDXS1('m','D','n','D'),SILK_PACK_NLSF_IDXS1('n','D','m','C'),
  SILK_PACK_NLSF_IDXS1('l','D','l','C'),SILK_PACK_NLSF_IDXS1('k','D','l','C'),
  /*I1=8*/
  SILK_PACK_NLSF_IDXS1('i','C','o','D'),SILK_PACK_NLSF_IDXS1('k','C','o','D'),
  SILK_PACK_NLSF_IDXS1('o','D','m','C'),SILK_PACK_NLSF_IDXS1('n','D','m','C'),
  SILK_PACK_NLSF_IDXS1('o','D','n','C'),SILK_PACK_NLSF_IDXS1('m','D','m','D'),
  SILK_PACK_NLSF_IDXS1('n','D','l','D'),SILK_PACK_NLSF_IDXS1('l','D','l','C'),
  /*I1=9*/
  SILK_PACK_NLSF_IDXS1('k','C','j','C'),SILK_PACK_NLSF_IDXS1('i','C','i','C'),
  SILK_PACK_NLSF_IDXS1('i','C','i','C'),SILK_PACK_NLSF_IDXS1('i','C','i','C'),
  SILK_PACK_NLSF_IDXS1('i','C','i','C'),SILK_PACK_NLSF_IDXS1('i','C','i','C'),
  SILK_PACK_NLSF_IDXS1('i','C','i','C'),SILK_PACK_NLSF_IDXS1('i','D','i','C'),
  /*I1=10*/
  SILK_PACK_NLSF_IDXS1('i','C','j','D'),SILK_PACK_NLSF_IDXS1('i','C','i','C'),
  SILK_PACK_NLSF_IDXS1('i','C','i','C'),SILK_PACK_NLSF_IDXS1('i','C','i','C'),
  SILK_PACK_NLSF_IDXS1('i','C','i','C'),SILK_PACK_NLSF_IDXS1('i','C','i','C'),
  SILK_PACK_NLSF_IDXS1('i','C','i','C'),SILK_PACK_NLSF_IDXS1('i','C','j','C'),
  /*I1=11*/
  SILK_PACK_NLSF_IDXS1('k','C','k','C'),SILK_PACK_NLSF_IDXS1('l','D','m','C'),
  SILK_PACK_NLSF_IDXS1('n','D','l','D'),SILK_PACK_NLSF_IDXS1('l','D','l','D'),
  SILK_PACK_NLSF_IDXS1('l','D','l','D'),SILK_PACK_NLSF_IDXS1('l','D','l','C'),
  SILK_PACK_NLSF_IDXS1('k','D','k','C'),SILK_PACK_NLSF_IDXS1('j','C','l','C'),
  /*I1=12*/
  SILK_PACK_NLSF_IDXS1('k','C','k','C'),SILK_PACK_NLSF_IDXS1('l','D','l','C'),
  SILK_PACK_NLSF_IDXS1('m','C','l','D'),SILK_PACK_NLSF_IDXS1('l','C','l','D'),
  SILK_PACK_NLSF_IDXS1('l','C','l','D'),SILK_PACK_NLSF_IDXS1('l','C','l','C'),
  SILK_PACK_NLSF_IDXS1('l','D','k','C'),SILK_PACK_NLSF_IDXS1('j','C','l','C'),
  /*I1=13*/
  SILK_PACK_NLSF_IDXS1('l','C','m','C'),SILK_PACK_NLSF_IDXS1('m','C','m','C'),
  SILK_PACK_NLSF_IDXS1('o','D','m','D'),SILK_PACK_NLSF_IDXS1('m','C','n','D'),
  SILK_PACK_NLSF_IDXS1('l','C','n','D'),SILK_PACK_NLSF_IDXS1('m','D','m','D'),
  SILK_PACK_NLSF_IDXS1('n','D','m','C'),SILK_PACK_NLSF_IDXS1('l','C','m','C'),
  /*I1=14*/
  SILK_PACK_NLSF_IDXS1('i','C','o','D'),SILK_PACK_NLSF_IDXS1('m','C','n','C'),
  SILK_PACK_NLSF_IDXS1('m','C','p','D'),SILK_PACK_NLSF_IDXS1('n','D','k','C'),
  SILK_PACK_NLSF_IDXS1('o','D','n','D'),SILK_PACK_NLSF_IDXS1('p','D','m','C'),
  SILK_PACK_NLSF_IDXS1('m','D','l','D'),SILK_PACK_NLSF_IDXS1('n','D','l','C'),
  /*I1=15*/
  SILK_PACK_NLSF_IDXS1('i','C','j','C'),SILK_PACK_NLSF_IDXS1('i','D','j','D'),
  SILK_PACK_NLSF_IDXS1('j','C','j','C'),SILK_PACK_NLSF_IDXS1('j','C','j','C'),
  SILK_PACK_NLSF_IDXS1('j','C','j','C'),SILK_PACK_NLSF_IDXS1('i','C','i','C'),
  SILK_PACK_NLSF_IDXS1('i','D','i','D'),SILK_PACK_NLSF_IDXS1('j','C','i','C'),
  /*I1=16*/
  SILK_PACK_NLSF_IDXS1('j','C','o','D'),SILK_PACK_NLSF_IDXS1('n','D','p','C'),
  SILK_PACK_NLSF_IDXS1('n','D','m','C'),SILK_PACK_NLSF_IDXS1('n','D','l','D'),
  SILK_PACK_NLSF_IDXS1('m','D','n','D'),SILK_PACK_NLSF_IDXS1('m','D','m','C'),
  SILK_PACK_NLSF_IDXS1('m','D','l','C'),SILK_PACK_NLSF_IDXS1('l','C','m','C'),
  /*I1=17*/
  SILK_PACK_NLSF_IDXS1('j','C','l','C'),SILK_PACK_NLSF_IDXS1('l','D','m','C'),
  SILK_PACK_NLSF_IDXS1('m','C','l','C'),SILK_PACK_NLSF_IDXS1('l','C','n','D'),
  SILK_PACK_NLSF_IDXS1('k','C','l','C'),SILK_PACK_NLSF_IDXS1('l','D','n','D'),
  SILK_PACK_NLSF_IDXS1('n','D','n','C'),SILK_PACK_NLSF_IDXS1('l','C','m','C'),
  /*I1=18*/
  SILK_PACK_NLSF_IDXS1('k','C','l','C'),SILK_PACK_NLSF_IDXS1('l','C','k','C'),
  SILK_PACK_NLSF_IDXS1('k','C','k','C'),SILK_PACK_NLSF_IDXS1('l','C','k','C'),
  SILK_PACK_NLSF_IDXS1('j','C','k','C'),SILK_PACK_NLSF_IDXS1('j','C','k','C'),
  SILK_PACK_NLSF_IDXS1('j','C','j','C'),SILK_PACK_NLSF_IDXS1('j','D','m','C'),
  /*I1=19*/
  SILK_PACK_NLSF_IDXS1('i','C','k','C'),SILK_PACK_NLSF_IDXS1('l','C','n','C'),
  SILK_PACK_NLSF_IDXS1('l','C','l','C'),SILK_PACK_NLSF_IDXS1('k','C','k','C'),
  SILK_PACK_NLSF_IDXS1('k','C','j','C'),SILK_PACK_NLSF_IDXS1('j','C','i','C'),
  SILK_PACK_NLSF_IDXS1('i','D','i','C'),SILK_PACK_NLSF_IDXS1('i','C','i','C'),
  /*I1=20*/
  SILK_PACK_NLSF_IDXS1('l','C','m','C'),SILK_PACK_NLSF_IDXS1('l','C','n','C'),
  SILK_PACK_NLSF_IDXS1('l','C','l','C'),SILK_PACK_NLSF_IDXS1('k','C','k','C'),
  SILK_PACK_NLSF_IDXS1('j','C','j','C'),SILK_PACK_NLSF_IDXS1('j','C','j','C'),
  SILK_PACK_NLSF_IDXS1('j','C','k','C'),SILK_PACK_NLSF_IDXS1('k','C','m','C'),
  /*I1=21*/
  SILK_PACK_NLSF_IDXS1('k','C','o','D'),SILK_PACK_NLSF_IDXS1('l','C','p','D'),
  SILK_PACK_NLSF_IDXS1('p','C','m','D'),SILK_PACK_NLSF_IDXS1('n','D','m','C'),
  SILK_PACK_NLSF_IDXS1('n','D','l','C'),SILK_PACK_NLSF_IDXS1('n','D','l','C'),
  SILK_PACK_NLSF_IDXS1('l','D','k','D'),SILK_PACK_NLSF_IDXS1('l','C','l','C'),
  /*I1=22*/
  SILK_PACK_NLSF_IDXS1('k','C','l','C'),SILK_PACK_NLSF_IDXS1('n','D','o','D'),
  SILK_PACK_NLSF_IDXS1('o','D','l','D'),SILK_PACK_NLSF_IDXS1('n','C','l','D'),
  SILK_PACK_NLSF_IDXS1('m','D','m','C'),SILK_PACK_NLSF_IDXS1('l','C','l','D'),
  SILK_PACK_NLSF_IDXS1('l','D','l','C'),SILK_PACK_NLSF_IDXS1('k','C','m','C'),
  /*I1=23*/
  SILK_PACK_NLSF_IDXS1('j','C','l','D'),SILK_PACK_NLSF_IDXS1('l','D','m','C'),
  SILK_PACK_NLSF_IDXS1('m','D','m','C'),SILK_PACK_NLSF_IDXS1('m','D','l','C'),
  SILK_PACK_NLSF_IDXS1('n','D','n','C'),SILK_PACK_NLSF_IDXS1('n','C','l','C'),
  SILK_PACK_NLSF_IDXS1('j','C','j','D'),SILK_PACK_NLSF_IDXS1('j','C','j','C'),
  /*I1=24*/
  SILK_PACK_NLSF_IDXS1('k','C','n','C'),SILK_PACK_NLSF_IDXS1('l','C','o','D'),
  SILK_PACK_NLSF_IDXS1('o','D','m','C'),SILK_PACK_NLSF_IDXS1('p','D','m','C'),
  SILK_PACK_NLSF_IDXS1('m','D','n','D'),SILK_PACK_NLSF_IDXS1('l','D','m','D'),
  SILK_PACK_NLSF_IDXS1('m','D','l','D'),SILK_PACK_NLSF_IDXS1('l','D','l','C'),
  /*I1=25*/
  SILK_PACK_NLSF_IDXS1('i','C','o','C'),SILK_PACK_NLSF_IDXS1('j','C','j','C'),
  SILK_PACK_NLSF_IDXS1('i','C','i','C'),SILK_PACK_NLSF_IDXS1('i','C','i','C'),
  SILK_PACK_NLSF_IDXS1('i','C','i','C'),SILK_PACK_NLSF_IDXS1('i','C','i','C'),
  SILK_PACK_NLSF_IDXS1('i','C','i','C'),SILK_PACK_NLSF_IDXS1('i','D','i','C'),
  /*I1=26*/
  SILK_PACK_NLSF_IDXS1('i','C','o','D'),SILK_PACK_NLSF_IDXS1('o','D','l','C'),
  SILK_PACK_NLSF_IDXS1('n','C','k','C'),SILK_PACK_NLSF_IDXS1('n','D','n','D'),
  SILK_PACK_NLSF_IDXS1('l','C','m','C'),SILK_PACK_NLSF_IDXS1('m','D','p','D'),
  SILK_PACK_NLSF_IDXS1('p','D','m','D'),SILK_PACK_NLSF_IDXS1('m','D','m','C'),
  /*I1=27*/
  SILK_PACK_NLSF_IDXS1('l','C','l','C'),SILK_PACK_NLSF_IDXS1('p','C','l','C'),
  SILK_PACK_NLSF_IDXS1('n','C','m','D'),SILK_PACK_NLSF_IDXS1('l','C','l','D'),
  SILK_PACK_NLSF_IDXS1('l','D','k','D'),SILK_PACK_NLSF_IDXS1('k','D','l','C'),
  SILK_PACK_NLSF_IDXS1('l','D','l','D'),SILK_PACK_NLSF_IDXS1('k','D','l','C'),
  /*I1=28*/
  SILK_PACK_NLSF_IDXS1('i','C','i','C'),SILK_PACK_NLSF_IDXS1('j','C','i','C'),
  SILK_PACK_NLSF_IDXS1('i','C','i','C'),SILK_PACK_NLSF_IDXS1('k','C','j','C'),
  SILK_PACK_NLSF_IDXS1('k','C','j','C'),SILK_PACK_NLSF_IDXS1('j','C','k','C'),
  SILK_PACK_NLSF_IDXS1('k','C','k','C'),SILK_PACK_NLSF_IDXS1('j','D','j','C'),
  /*I1=29*/
  SILK_PACK_NLSF_IDXS1('i','C','l','C'),SILK_PACK_NLSF_IDXS1('k','C','n','C'),
  SILK_PACK_NLSF_IDXS1('l','C','l','C'),SILK_PACK_NLSF_IDXS1('k','C','l','C'),
  SILK_PACK_NLSF_IDXS1('k','C','j','C'),SILK_PACK_NLSF_IDXS1('i','C','i','C'),
  SILK_PACK_NLSF_IDXS1('j','C','i','C'),SILK_PACK_NLSF_IDXS1('i','D','j','C'),
  /*I1=30*/
  SILK_PACK_NLSF_IDXS1('l','D','n','C'),SILK_PACK_NLSF_IDXS1('n','C','m','C'),
  SILK_PACK_NLSF_IDXS1('p','C','n','C'),SILK_PACK_NLSF_IDXS1('l','C','l','C'),
  SILK_PACK_NLSF_IDXS1('k','C','l','C'),SILK_PACK_NLSF_IDXS1('k','C','k','D'),
  SILK_PACK_NLSF_IDXS1('j','C','i','C'),SILK_PACK_NLSF_IDXS1('j','C','i','C'),
  /*I1=31*/
  SILK_PACK_NLSF_IDXS1('k','C','l','C'),SILK_PACK_NLSF_IDXS1('n','D','l','C'),
  SILK_PACK_NLSF_IDXS1('m','C','l','D'),SILK_PACK_NLSF_IDXS1('l','D','l','D'),
  SILK_PACK_NLSF_IDXS1('k','C','j','C'),SILK_PACK_NLSF_IDXS1('k','D','o','C'),
  SILK_PACK_NLSF_IDXS1('m','C','i','D'),SILK_PACK_NLSF_IDXS1('i','C','i','C')
};

static const unsigned char SILK_WB_NLSF_STAGE2_PRED_WEIGHTS_Q8[2*16]={
  175,148,160,176,178,173,174,164,177,174,196,182,198,192,182,
   68, 62, 66, 60, 72,117, 85, 90,118,136,151,142,160,142,155
};

static const opus_int16 SILK_WB_NLSF_MIN_SPACING_Q15[17]={
  100,  3, 40,  3,  3,  3,  5, 14, 14, 10, 11,  3,  8,  9,  7,  3,347
};

static const unsigned char SILK_WB_NLSF_ORDERING[16]={
  0,15, 8, 7, 4,11,12, 3, 2,13,10, 5, 6, 9,14, 1
};

const silk_nlsf_codebook SILK_WB_NLSF_CODEBOOK={
  /*Stage 1 PDFs:*/
  {
    /*Inactive or Unvoiced.*/
    31, 21,  3, 17,  1,  8, 17,  4,  1, 18, 16,  4,  2,  3,  1, 10,
     1,  3, 16, 11, 16,  2,  2,  3,  2, 11,  1,  4,  9,  8,  7,  3,
    /*Voiced.*/
     1,  4, 16,  5, 18, 11,  5, 14, 15,  1,  3, 12, 13, 14, 14,  6,
    14, 12,  2,  6,  1, 12, 12, 11, 10,  3, 10,  5,  1,  1,  1,  3
  },
  /*Stage 2 PDFs:*/
  {
    1, 1,  1,  9, 232,  9,  1,  1,  1,
    1, 1,  2, 28, 186, 35,  1,  1,  1,
    1, 1,  3, 42, 152, 53,  2,  1,  1,
    1, 1, 10, 49, 126, 65,  2,  1,  1,
    1, 4, 19, 48, 100, 77,  5,  1,  1,
    1, 1, 14, 54, 100, 72, 12,  1,  1,
    1, 1, 15, 61,  87, 61, 25,  4,  1,
    1, 7, 21, 50,  77, 81, 17,  1,  1
  },
  SILK_WB_NLSF_STAGE1_CB_Q8,
  SILK_WB_NLSF_STAGE2_INDICES,
  SILK_WB_NLSF_STAGE2_PRED_WEIGHTS_Q8,
  SILK_WB_NLSF_MIN_SPACING_Q15,
  SILK_WB_NLSF_ORDERING,
  9830,
  16
};


const silk_nlsf_codebook *const SILK_NLSF_CODEBOOKS[3]={
  &SILK_NBMB_NLSF_CODEBOOK,
  &SILK_NBMB_NLSF_CODEBOOK,
  &SILK_WB_NLSF_CODEBOOK
};



const opus_int16 SILK_COS_Q12[129]={
   4096, 4095, 4091, 4085, 4076, 4065, 4052, 4036,
   4017, 3997, 3973, 3948, 3920, 3889, 3857, 3822,
   3784, 3745, 3703, 3659, 3613, 3564, 3513, 3461,
   3406, 3349, 3290, 3229, 3166, 3102, 3035, 2967,
   2896, 2824, 2751, 2676, 2599, 2520, 2440, 2359,
   2276, 2191, 2106, 2019, 1931, 1842, 1751, 1660,
   1568, 1474, 1380, 1285, 1189, 1093,  995,  897,
    799,  700,  601,  501,  401,  301,  201,  101,
      0, -101, -201, -301, -401, -501, -601, -700,
   -799, -897, -995,-1093,-1189,-1285,-1380,-1474,
  -1568,-1660,-1751,-1842,-1931,-2019,-2106,-2191,
  -2276,-2359,-2440,-2520,-2599,-2676,-2751,-2824,
  -2896,-2967,-3035,-3102,-3166,-3229,-3290,-3349,
  -3406,-3461,-3513,-3564,-3613,-3659,-3703,-3745,
  -3784,-3822,-3857,-3889,-3920,-3948,-3973,-3997,
  -4017,-4036,-4052,-4065,-4076,-4085,-4091,-4095,
  -4096
};


const signed char SILK_SUBFRAME_PITCH_CBS[210]={
  /*10 ms NB frames:*/
   0, 0,
   1, 0,
   0, 1,
  /*20 ms NB frames:*/
   0, 0, 0, 0,
   2, 1, 0,-1,
  -1, 0, 1, 2,
  -1, 0, 0, 1,
  -1, 0, 0, 0,
   0, 0, 0, 1,
   0, 0, 1, 1,
   1, 1, 0, 0,
   1, 0, 0, 0,
   0, 0, 0,-1,
   1, 0, 0,-1,
  /*10 ms MB or WB frames:*/
   0, 0,
   0, 1,
   1, 0,
  -1, 1,
   1,-1,
  -1, 2,
   2,-1,
  -2, 2,
   2,-2,
  -2, 3,
   3,-2,
  -3, 3,
  /*20 ms MB or WB frames:*/
   0, 0, 0, 0,
   0, 0, 1, 1,
   1, 1, 0, 0,
  -1, 0, 0, 0,
   0, 0, 0, 1,
   1, 0, 0, 0,
  -1, 0, 0, 1,
   0, 0, 0,-1,
  -1, 0, 1, 2,
   1, 0, 0,-1,
  -2,-1, 1, 2,
   2, 1, 0,-1,
  -2, 0, 0, 2,
  -2, 0, 1, 3,
   2, 1,-1,-2,
  -3,-1, 1, 3,
   2, 0, 0,-2,
   3, 1, 0,-2,
  -3,-1, 2, 4,
  -4,-1, 1, 4,
   3, 1,-1,-3,
  -4,-1, 2, 5,
   4, 2,-1,-3,
   4, 1,-1,-4,
  -5,-1, 2, 6,
   5, 2,-1,-4,
  -6,-2, 2, 6,
  -5,-2, 2, 5,
   6, 2,-1,-5,
  -7,-2, 3, 8,
   6, 2,-2,-6,
   5, 2,-2,-5,
   8, 3,-2,-7,
  -9,-3, 3, 9
};

const unsigned char SILK_SUBFRAME_PITCH_CB_OFFS[4]={
  0, 6,50,74
};

const signed char SILK_LTP_FILTER_CBS_Q7[56*5]={
  /*Periodicity Index 0:*/
    4,  6, 24,  7,  5,
    0,  0,  2,  0,  0,
   12, 28, 41, 13, -4,
   -9, 15, 42, 25, 14,
    1, -2, 62, 41, -9,
  -10, 37, 65, -4,  3,
   -6,  4, 66,  7, -8,
   16, 14, 38, -3, 33,
  /*Periodicity Index 1:*/
   13, 22, 39, 23, 12,
   -1, 36, 64, 27, -6,
   -7, 10, 55, 43, 17,
    1,  1,  8,  1,  1,
    6,-11, 74, 53, -9,
  -12, 55, 76,-12,  8,
   -3,  3, 93, 27, -4,
   26, 39, 59,  3, -8,
    2,  0, 77, 11,  9,
   -8, 22, 44, -6,  7,
   40,  9, 26,  3,  9,
   -7, 20,101, -7,  4,
    3, -8, 42, 26,  0,
  -15, 33, 68,  2, 23,
   -2, 55, 46, -2, 15,
    3, -1, 21, 16, 41,
  /*Periodicity Index 2:*/
   -6, 27, 61, 39,  5,
  -11, 42, 88,  4,  1,
   -2, 60, 65,  6, -4,
   -1, -5, 73, 56,  1,
   -9, 19, 94, 29, -9,
    0, 12, 99,  6,  4,
    8,-19,102, 46,-13,
    3,  2, 13,  3,  2,
    9,-21, 84, 72,-18,
  -11, 46,104,-22,  8,
   18, 38, 48, 23,  0,
  -16, 70, 83,-21, 11,
    5,-11,117, 22, -8,
   -6, 23,117,-12,  3,
    3, -8, 95, 28,  4,
  -10, 15, 77, 60,-15,
   -1,  4,124,  2, -4,
    3, 38, 84, 24,-25,
    2, 13, 42, 13, 31,
   21, -4, 56, 46, -1,
   -1, 35, 79,-13, 19,
   -7, 65, 88, -9,-14,
   20,  4, 81, 49,-29,
   20,  0, 75,  3,-17,
    5, -9, 44, 92, -8,
    1, -3, 22, 69, 31,
   -6, 95, 41,-12,  5,
   39, 67, 16, -4,  1,
    0, -6,120, 55,-36,
  -13, 44,122,  4,-24,
   81,  5, 11,  3,  7,
    2,  0,  9, 10, 88
};

const opus_int16 SILK_LTP_SCALE_CB_Q14[3]={
  15565,12288, 8192
};

const opus_int16 SILK_QUANT_OFFSET_Q29[6]={
  1600,3840,1600,3840, 512,1600
};
